package com.simbir.account_sever.security.services;

import com.simbir.account_sever.security.dto.JwtResponseDto;
import com.simbir.account_sever.security.dto.JwtValidateResponseDto;
import com.simbir.account_sever.security.dto.params.JwtRefreshParams;
import com.simbir.account_sever.security.dto.params.SignInParams;
import com.simbir.account_sever.security.dto.params.SignUpParams;

import java.util.UUID;

public interface UserSecurityService {

    JwtResponseDto signUp(SignUpParams params);

    JwtResponseDto signIn(SignInParams params);

    void signOut(UUID tokenId);

    JwtValidateResponseDto validateToken(String accessToken);

    JwtResponseDto refreshToken(JwtRefreshParams params);
}
