package com.simbir.account_sever.services;

import com.simbir.account_sever.dto.params.AdminCreateOrUpdateUserParams;
import com.simbir.account_sever.dto.params.CreateOrUpdateUserParams;
import com.simbir.account_sever.entities.UserEntity;
import com.simbir.account_sever.entities.role.UserRoleEntityId;
import org.springframework.data.domain.Slice;

import java.util.Collection;
import java.util.List;

public interface UserService {

    UserEntity getById(long id);

    UserEntity getById(long id, UserRoleEntityId.Role role);

    UserEntity getByUsername(String username);

    UserEntity getByUsernameWithRoles(String username);

    Slice<UserEntity> getAll(int offset, int limit);

    void update(long id, AdminCreateOrUpdateUserParams params);

    void update(long id, CreateOrUpdateUserParams params);

    void update(UserEntity user, boolean passwordEncoding);

    UserEntity create(AdminCreateOrUpdateUserParams params);

    UserEntity create(UserEntity user);

    void softDelete(long id, String accessToken);

    boolean isExists(long id, Collection<UserRoleEntityId.Role> roles, boolean requireAll);

    void updateRoles(UserEntity user, List<UserRoleEntityId.Role> roles);
}
