package com.simber.market.common.security.authenticate;

import com.simber.market.common.security.authenticate.models.LogicalOperation;
import com.simber.market.common.security.user.models.UserRole;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target({ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
@SecurityRequirement(name = "bearerAuth")
public @interface Authenticate {
    UserRole[] roles() default {};

    String parameterUserId() default "";

    LogicalOperation operation() default LogicalOperation.OR;
}
