package com.simber.market.entities;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Collection;

@Getter
@Setter
@Entity(name = "products")
public class ProductEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String name;
    private String description;
    private Double price;

    private Long ownerId;

    private Integer amount = 0;

    private Boolean isDeleted = false;

    @OneToMany(mappedBy = "id.product")
    private Collection<ProductTagEntity> tags = new ArrayList<>();
}
