package com.simber.market.repositories;

import com.simber.market.entities.ProductEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;

public interface ProductRepository extends JpaRepository<ProductEntity, Long> {

    @Query("SELECT p FROM products p WHERE p.isDeleted = false")
    List<ProductEntity> findAllActive();

    @Query("SELECT p FROM products p WHERE p.isDeleted = false AND p.id = :id")
    Optional<ProductEntity> findByIdActive(Long id);
}
