package com.simber.market.services;

import com.simber.market.common.security.user.models.UserRole;
import com.simber.market.common.security.user.models.UserSessionDetails;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.server.ResponseStatusException;

@Service
@RequiredArgsConstructor
public class ProductAuthorizationService {

    private final ProductService productService;

    @Transactional(readOnly = true, noRollbackFor = ResponseStatusException.class)
    public boolean accessDeleteProductById(Long id, UserSessionDetails userSession) {
        if (userSession.getRoles().contains(UserRole.Admin)) return true;

        try {
            var product = productService.getById(id);
            return product.getOwnerId().equals(userSession.getId());
        }catch (ResponseStatusException ex) {
            return false;
        }
    }
}
