package com.simber.market.services;

import com.simber.market.dto.CreateOrUpdateProductParams;
import com.simber.market.dto.IncreaseProductParams;
import com.simber.market.entities.ProductEntity;

import java.util.Collection;

public interface ProductService {

    Collection<ProductEntity> getAll(String name, Collection<String> tags);

    ProductEntity getById(Long id);

    ProductEntity create(Long ownerId, CreateOrUpdateProductParams params);

    void update(Long id, CreateOrUpdateProductParams params);

    void delete(Long id);

    void increase(Long productId, IncreaseProductParams params);

    void decrease(Long productId, IncreaseProductParams params);
}
