package com.simber.payment;

import com.simber.payment.common.security.authenticate.Authenticate;
import com.simber.payment.common.security.context.SecurityContextHolder;
import com.simber.payment.dto.CardExistParams;
import com.simber.payment.purchase.client.PurchaseClient;
import com.simber.payment.services.CardService;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
@RequiredArgsConstructor
@RequestMapping("/api/Payment")
public class PaymentController {

    private final CardService cardService;

    private final PurchaseClient purchaseClient;

    @PostMapping("/Pay/{paymentId}")
    public void pay(
            @PathVariable Long paymentId,
            @RequestBody CardExistParams params
    ) {
        if (!cardService.exist(params)) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Card invalid");
        }
        purchaseClient.updateStatusToPaid(paymentId);
    }
}
