package com.simber.payment.services;

import com.simber.payment.dto.CardExistParams;
import com.simber.payment.repositories.CardRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@RequiredArgsConstructor
public class CardServiceImpl implements CardService {

    private final CardRepository cardRepository;

    @Override
    @Transactional(readOnly = true)
    public boolean exist(CardExistParams params) {
        return cardRepository.findAll().stream().anyMatch(c -> c.getName().equals(params.name())
                && c.getCvv().equals(params.cvv()) && c.getNumber().equals(params.cardNumber())
                && c.getDate().equals(params.expireDate()));
    }
}
