package com.simber.purchase.product.client;

import com.simber.purchase.product.client.params.IncreaseProductParams;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

@FeignClient(name = "product-service", url = "${feign.clients.product.url}")
public interface ProductClient {

    @GetMapping("/Products")
    boolean exists(@PathVariable Long id, @RequestHeader("Authorization") String accessToken);

    @PostMapping("/Products/{id}/Increase/Service")
    void increase(@PathVariable Long id, @RequestBody IncreaseProductParams params, @RequestHeader("Authorization") String accessToken);

    @PostMapping("/Products/{id}/Decrease/Service")
    void decrease(@PathVariable Long id, @RequestBody IncreaseProductParams params, @RequestHeader("Authorization") String accessToken);
}
