package com.simber.purchase.repositories;

import com.simber.purchase.entities.PurchaseEntity;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Slice;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.Optional;

public interface PurchaseRepository extends JpaRepository<PurchaseEntity, Long> {

    @Query("SELECT p FROM purchase p WHERE p.paymentId = :paymentId")
    Optional<PurchaseEntity> findByPaymentId(Long paymentId);

    @Query("SELECT p FROM purchase p")
    Slice<PurchaseEntity> findAllSlice(Pageable pageable);

    @Query("SELECT p FROM purchase p WHERE p.userId = :userId")
    Slice<PurchaseEntity> findAllByUserIdSlice(Long userId, Pageable pageable);

}
