package com.simber.purchase.user.client;

import com.simber.purchase.common.security.user.models.UserRole;
import com.simber.purchase.user.client.models.UserModel;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Collection;

@FeignClient(name = "user-service", url = "${feign.clients.account.url}")
public interface UserServiceClient {

    @GetMapping("/Authentication/Validate")
    UserModel validationAccessToken(@RequestParam String accessToken);

    @GetMapping("/Accounts/{id}/Is-Exists")
    boolean exists(@PathVariable Long id, @RequestParam Collection<UserRole> roles, @RequestParam boolean requireAll, @RequestHeader("Authorization") String accessToken);
}
